%% Simulation 4: real data
clear all; clc; close all;
%% load data sets
load('EQ5.mat'); %load data (earthquake)
load('EXP6.mat'); %load data (explosion)
load('Speech.mat'); %load data (speech data)
load('data_SP500.mat');
%% choose one data from (EQ5, EXP6, normalized-centered-Speech)
%% approx_conf: 0: data is not long enough, don't approx conf interval
%% choose Earthquake data
%approx_conf=1; mydata=EQ5; mydata_title='Earthquake Data';t1=4;t2=6;t3=8;t4=10;f1=2;f2=4;f3=6;f4=8;
%% 
%% choose Exploison data
%approx_conf=1; mydata=EXP6; mydata_title='Explosion Data';t1=4;t2=6;t3=8;t4=10;f1=2;f2=4;f3=6;f4=8;
%% (not used) choose speech data
%NOT USED approx_conf=0; mydata=(Speech-mean(Speech))/(max(abs(Speech-mean(Speech)))); mydata_title='Speech Data';t1=1;t2=4;t3=7;t4=10;f1=3;f2=4;f3=5;f4=6;
%% I computed return by (data_SP500_Close-data_SP500_Open)./data_SP500_Open;
%% choose SP500 data, pure return (centered), data is long enough, choose approx confidence interval
%approx_conf=1; mydata=data_SP500_return-mean(data_SP500_return); mydata_title='Daily Returns of SP500'; t1=5;t2=10;t3=15;t4=20;f1=6;f2=8;f3=10;f4=12;
%% SP500 abs return (remove mean by smoothing)
 % for smoothing
 my_bandwidth=sqrt(length(data_SP500_return)); %choose bandwidth for smoothing
 my_raw=abs(data_SP500_return);
 my_smooth=smoothing(abs(data_SP500_return),my_bandwidth);
 figure(999); N1=length(my_raw); plot([1:N1],my_raw,':',[1:N1],my_smooth,'-k'); xlabel('time'); legend('Absolute Daily Return','Kernel Smoothing');xlim([1,N1]);
 approx_conf=1; mydata=my_raw-my_smooth; mydata_title='Absolute SP500'; t1=2;t2=10;t3=16;t4=20;f1=1;f2=3;f3=5;f4=7;
%%
N1=length(mydata);
figure(1);plot([1:N1],mydata); xlim([1 N1]); title('raw data');
%% select n and BnFFT for data
[n1,BnFFT1]=my_select_n_BnFFT(mydata);
disp('plug the selected BnFFT and n into 2*log(BnFFT)*BnFFT/n: '); 2*log(BnFFT1)*BnFFT1/n1
%% adjust n1 if want to have largest time intervals
%[n1,BnFFT1]=my_select_BnFFT_with_max_n(mydata);
%n1=BnFFT1; %smallest n1 possible
%%
Bn1=floor(BnFFT1/2); % Bn: the effective number of frequencies is half of BnFFT+1 (discarded the last one)
if (BnFFT1>n1)
    disp('error: BnFFT>n');
    return;
end
%% Generating u
du1=n1/N1*(1-1/(log(Bn1))^2); % du: fixed interval size between time
u1=[n1/2/N1:du1:1-n1/2/N1]'; % u: the vector of times 
Cn1=size(u1,1); % Cn: number of time points


%% time-frequency estimates of mydata
f_res1=zeros(Bn1,length(u1));
for jj=1:length(u1)
    current_u=u1(jj);
    f_res1(:,jj)=my_spectral_estimate_fft(mydata,n1,BnFFT1,Bn1,current_u);
end
% plot time-frequency estimates
figure(2); s1=mesh(f_res1);title('time-frequency estimates'); xlim([1 Cn1]); ylim([1 Bn1]);
figure(3);surface(f_res1);title('time-frequency estimates'); xlim([1 Cn1]); ylim([1 Bn1]);


%% generate bootstrapped interval for mydata
per1=0.95; % per: 95% or 90%
per2=0.9;
MonteCarlo1=10000; % MonteCarlo1: number of Monte Carlo for generating bootstrapped interval
%MonteCarlo2=10000;
% bootstrap 95% and 90% interval for mydata
[int1_l,mydata_int1,int2_l,mydata_int2,mydata_maxdev,mydata_avg]=my_bootstrap_fft(u1,N1,n1,BnFFT1,Bn1,MonteCarlo1,per1,per2);
%% compute confidence band
%mydata
%% temp!!!! remove frequency=0 for abs SP500 return
% if remove_f0==1
%     f_res1_temp=f_res1(2:Bn1,:);
%     f_res1=zeros(Bn1-1,Cn1);
%     f_res1=f_res1_temp;
%     Bn1=Bn1-1;
% end
%% don't choose approximation
if approx_conf==0
    f_res1_up1=f_res1*(1+sqrt(mydata_int1)); % 95% upper
    f_res1_down1=max(0,f_res1*(1-sqrt(mydata_int1))); %95% lower
    f_res1_up2=f_res1*(1+sqrt(mydata_int2)); % 90% upper
    f_res1_down2=max(0,f_res1*(1-sqrt(mydata_int2))); %90% lower
else
%% choose approximation
    f_res1_up1=f_res1*(exp(sqrt(mydata_int1))); % 95% upper
    f_res1_down1=f_res1*(exp(-sqrt(mydata_int1))); %95% lower band using log() approx
    f_res1_up2=f_res1*(exp(sqrt(mydata_int2))); % 90% upper
    f_res1_down2=f_res1*(exp(-sqrt(mydata_int2))); % 90% lower band using log() approx
end

%figure(4); s2=mesh(f_res1_up1); title('upper band of time-frequency inference')%figure(7); mesh(f_res1_up2);



%% assuming stationary
%mydata
%g_res1=my_spectral_estimate_fft(mydata,N1,BnFFT1,Bn1,0.5);
%f_res1_min_upper=min(f_res1_up1,[],2); %compute minimum over time upper bounds for every frequency
%f_res1_min=min(f_res1,[],2);
%f_res1_max=max(f_res1,[],2);
%figure(5); 
%plot([1:Bn1],f_res1_min_upper,'v:',[1:Bn1],g_res1,'-',[1:Bn1],f_res1_min,'+-',[1:Bn1],f_res1_max,'--');xlabel('Frequency');legend('Minimum 95% Simutanous Upper Band','Stationary','Minimum Estimate','Maximum Estimate');
%title('Assuming stationarity');
%g_res1_grid=repmat(g_res1,1,length(u1));
%figure(6); mesh(g_res1_grid); title('Assuming stationarity');


%% plot multiple surfaces 
% [X,Y]=meshgrid(1:Cn1,1:Bn1);
% subplot(2,2,4);
% s1=surf(X,Y,f_res1_up1); alpha(s1,0.1);
% hold on
% s2=surf(X,Y,f_res1_down1); alpha(s2,1);
% hold off
%colormap([1 0 0;0 0 1]) 
%figure(7); s1=surf(X,Y,f_res1_up1); alpha(s1,0.1);
%hold on
%s2=surf(X,Y,f_res1_down1); alpha(s2, 1);
%hold on
%s0=surf(X,Y,f_res1); alpha(s0,0.3);
%view(17,22)
%hold off

%% plot confidence region for different time

formatSpec = 'different frequencies at u=%0.2f.';
str_t1 = sprintf(formatSpec,t1/Cn1);
str_t2 = sprintf(formatSpec,t2/Cn1);
str_t3 = sprintf(formatSpec,t3/Cn1);
str_t4 = sprintf(formatSpec,t4/Cn1);
formatSpec2= 'different time at %s=%0.2f%s';
str_f1 = sprintf(formatSpec2,'\theta',f1/Bn1,'\pi');
str_f2 = sprintf(formatSpec2,'\theta',f2/Bn1,'\pi');
str_f3 = sprintf(formatSpec2,'\theta',f3/Bn1,'\pi');
str_f4 = sprintf(formatSpec2,'\theta',f4/Bn1,'\pi');
% figure(8);
% plot([1:Bn1],f_res1(:,t1),'v:',[1:Bn1],f_res1_up1(:,t1),'-',[1:Bn1],f_res1_down1(:,t1),'+-',[1:Bn1],f_res1_up2(:,t1),'--',[1:Bn1],f_res1_down2(:,t1),':d');
% xlabel(str_t1);
% legend('Density Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
% xlim([1 Bn1]);


% figure(9);
% plot([1:Cn1],f_res1(f1,:),'v:',[1:Cn1],f_res1_up1(f1,:),'-',[1:Cn1],f_res1_down1(f1,:),'+-',[1:Cn1],f_res1_up2(f1,:),'--',[1:Cn1],f_res1_down2(f1,:),':d');
% xlabel('Time');
% legend('Density Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
% xlim([1 Cn1]);




%%
figure(1); 
subplot(2,2,1); %
plot([1:N1],mydata); xlim([1 N1]); title(mydata_title); xlabel('time');
subplot(2,2,2); % time-frequency estimates in mesh
s1=mesh(f_res1);title('Time-frequency Estimates'); xlim([1 Cn1]); ylim([1 Bn1]); zlim([0 inf]); xlabel('time');ylabel('freq');
subplot(2,2,3); % time-frequency estimates in surface
surface(f_res1);title('Time-frequency Estimates'); xlim([1 Cn1]); ylim([1 Bn1]); zlim([0 inf]);
[X,Y]=meshgrid(1:Cn1,1:Bn1);xlabel('time');ylabel('freq');
subplot(2,2,4); % 95% upper lower band in one plot
s1=surf(X,Y,f_res1_up1); alpha(s1,0.1); title('95% SCR');xlim([1 Cn1]); ylim([1 Bn1]);
hold on
s2=surf(X,Y,f_res1_down1); alpha(s2,0.6); xlim([1 Cn1]); ylim([1 Bn1]); zlim([0 inf]); xlabel('time');ylabel('freq');
hold off


%%
figure(2);
subplot(2,2,1); % frequency at 4 times, t1
plot([1:Bn1],f_res1(:,t1),'-',[1:Bn1],f_res1_up1(:,t1),'-.',[1:Bn1],f_res1_down1(:,t1),'+-',[1:Bn1],f_res1_up2(:,t1),'--',[1:Bn1],f_res1_down2(:,t1),':');
xlabel(str_t1);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');xlim([1 Bn1]);
subplot(2,2,2); % frequency at 4 times, t2
plot([1:Bn1],f_res1(:,t2),'-',[1:Bn1],f_res1_up1(:,t2),'-.',[1:Bn1],f_res1_down1(:,t2),'+-',[1:Bn1],f_res1_up2(:,t2),'--',[1:Bn1],f_res1_down2(:,t2),':');
xlabel(str_t2);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');xlim([1 Bn1]);
subplot(2,2,3); % frequency at 4 times, t3
plot([1:Bn1],f_res1(:,t3),'-',[1:Bn1],f_res1_up1(:,t3),'-.',[1:Bn1],f_res1_down1(:,t3),'+-',[1:Bn1],f_res1_up2(:,t3),'--',[1:Bn1],f_res1_down2(:,t3),':');
xlabel(str_t3);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');xlim([1 Bn1]);
subplot(2,2,4); % frequency at 4 times, t4
plot([1:Bn1],f_res1(:,t4),'-',[1:Bn1],f_res1_up1(:,t4),'-.',[1:Bn1],f_res1_down1(:,t4),'+-',[1:Bn1],f_res1_up2(:,t4),'--',[1:Bn1],f_res1_down2(:,t4),':');
xlabel(str_t4);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');xlim([1 Bn1]);

%%
figure(3);
subplot(2,2,1); % time at 4 frequencies, f1
plot([1:Cn1],f_res1(f1,:),'-',[1:Cn1],f_res1_up1(f1,:),'-.',[1:Cn1],f_res1_down1(f1,:),'+-',[1:Cn1],f_res1_up2(f1,:),'--',[1:Cn1],f_res1_down2(f1,:),':');
xlabel(str_f1);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
xlim([1 Cn1]);
subplot(2,2,2); % time at 4 frequencies, f2
plot([1:Cn1],f_res1(f2,:),'-',[1:Cn1],f_res1_up1(f2,:),'-.',[1:Cn1],f_res1_down1(f2,:),'+-',[1:Cn1],f_res1_up2(f2,:),'--',[1:Cn1],f_res1_down2(f2,:),':');
xlabel(str_f2);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
xlim([1 Cn1]);
subplot(2,2,3); % time at 4 frequencies, f3
plot([1:Cn1],f_res1(f3,:),'-',[1:Cn1],f_res1_up1(f3,:),'-.',[1:Cn1],f_res1_down1(f3,:),'+-',[1:Cn1],f_res1_up2(f3,:),'--',[1:Cn1],f_res1_down2(f3,:),':');
xlabel(str_f3);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
xlim([1 Cn1]);
subplot(2,2,4); % time at 4 frequencies, f4
plot([1:Cn1],f_res1(f4,:),'-',[1:Cn1],f_res1_up1(f4,:),'-.',[1:Cn1],f_res1_down1(f4,:),'+-',[1:Cn1],f_res1_up2(f4,:),'--',[1:Cn1],f_res1_down2(f4,:),':');
xlabel(str_f4);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
xlim([1 Cn1]);

%% more plots , x axis is actual time or frequency
figure(66);
subplot(2,2,1); % frequency at 4 times, t1
x_axis=[1:Bn1]/Bn1*pi;
plot(x_axis,f_res1(:,t1),'-',x_axis,f_res1_up1(:,t1),'-.',x_axis,f_res1_down1(:,t1),'+-',x_axis,f_res1_up2(:,t1),'--',x_axis,f_res1_down2(:,t1),':');
xlabel(str_t1);
set(gca,'xtick',[0 pi/4 pi/2 pi*3/4 pi]);
set(gca,'xticklabel',{'0','\pi/4','\pi/2','3\pi/4','\pi'});
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');xlim([1 Bn1]);
xlim([min(x_axis) max(x_axis)]);
subplot(2,2,2); % frequency at 4 times, t2
plot(x_axis,f_res1(:,t2),'-',x_axis,f_res1_up1(:,t2),'-.',x_axis,f_res1_down1(:,t2),'+-',x_axis,f_res1_up2(:,t2),'--',x_axis,f_res1_down2(:,t2),':');
xlabel(str_t2);
set(gca,'xtick',[0 pi/4 pi/2 pi*3/4 pi]);
set(gca,'xticklabel',{'0','\pi/4','\pi/2','3\pi/4','\pi'});
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');xlim([1 Bn1]);
xlim([min(x_axis) max(x_axis)]);
subplot(2,2,3); % frequency at 4 times, t3
plot(x_axis,f_res1(:,t3),'-',x_axis,f_res1_up1(:,t3),'-.',x_axis,f_res1_down1(:,t3),'+-',x_axis,f_res1_up2(:,t3),'--',x_axis,f_res1_down2(:,t3),':');
xlabel(str_t3);
set(gca,'xtick',[0 pi/4 pi/2 pi*3/4 pi]);
set(gca,'xticklabel',{'0','\pi/4','\pi/2','3\pi/4','\pi'});
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');xlim([1 Bn1]);
xlim([min(x_axis) max(x_axis)]);
subplot(2,2,4); % frequency at 4 times, t4
plot(x_axis,f_res1(:,t4),'-',x_axis,f_res1_up1(:,t4),'-.',x_axis,f_res1_down1(:,t4),'+-',x_axis,f_res1_up2(:,t4),'--',x_axis,f_res1_down2(:,t4),':');
xlabel(str_t4);
set(gca,'xtick',[0 pi/4 pi/2 pi*3/4 pi]);
set(gca,'xticklabel',{'0','\pi/4','\pi/2','3\pi/4','\pi'});
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');xlim([1 Bn1]);
xlim([min(x_axis) max(x_axis)]);
%%
figure(77);
subplot(2,2,1); % time at 4 frequencies, f1
x_axis=[1:Cn1]/Cn1;
plot(x_axis,f_res1(f1,:),'-',x_axis,f_res1_up1(f1,:),'-.',x_axis,f_res1_down1(f1,:),'+-',x_axis,f_res1_up2(f1,:),'--',x_axis,f_res1_down2(f1,:),':');
xlabel(str_f1);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
xlim([min(x_axis) max(x_axis)]);
subplot(2,2,2); % time at 4 frequencies, f2
plot(x_axis,f_res1(f2,:),'-',x_axis,f_res1_up1(f2,:),'-.',x_axis,f_res1_down1(f2,:),'+-',x_axis,f_res1_up2(f2,:),'--',x_axis,f_res1_down2(f2,:),':');
xlabel(str_f2);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
xlim([min(x_axis) max(x_axis)]);
subplot(2,2,3); % time at 4 frequencies, f3
plot(x_axis,f_res1(f3,:),'-',x_axis,f_res1_up1(f3,:),'-.',x_axis,f_res1_down1(f3,:),'+-',x_axis,f_res1_up2(f3,:),'--',x_axis,f_res1_down2(f3,:),':');
xlabel(str_f3);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
xlim([min(x_axis) max(x_axis)]);
subplot(2,2,4); % time at 4 frequencies, f4
plot(x_axis,f_res1(f4,:),'-',x_axis,f_res1_up1(f4,:),'-.',x_axis,f_res1_down1(f4,:),'+-',x_axis,f_res1_up2(f4,:),'--',x_axis,f_res1_down2(f4,:),':');
xlabel(str_f4);
legend('Estimate','95% Upper','95% Lower','90% Upper','90% Lower');    
xlim([min(x_axis) max(x_axis)]);

%% testing stationarity, time-varying white noise, and correlation stationarity
%% note that size(f_res1)=(Bn,Cn)
my_test=zeros(1,6);
my_pval=zeros(1,3);
my_crit=zeros(1,3);
   %% power1 (stationarity): 
    h_theta=mean(f_res1,2); %col vector
    h_theta_min1=min(f_res1_up1')'; %col vector
    h_theta_min2=min(f_res1_up2')'; %col vector
    h_theta_max1=max(f_res1_down1')'; %col vector
    h_theta_max2=max(f_res1_down2')'; %col vector
    my_test(1)=max((h_theta_max1>h_theta)+(h_theta>h_theta_min1));
    my_test(2)=max((h_theta_max2>h_theta)+(h_theta>h_theta_min2));
    f_test_stationary=repmat(h_theta,1,Cn1);
    %% power2 (white noise):
    g_u=mean(f_res1,1); %row vector
    g_u_min1=min(f_res1_up1); %row vector
    g_u_min2=min(f_res1_up2); %row vector
    g_u_max1=max(f_res1_down1); %row vector
    g_u_max2=max(f_res1_down2); %row vector
    my_test(3)=max((g_u_max1>g_u)+(g_u>g_u_min1));
    my_test(4)=max((g_u_max2>g_u)+(g_u>g_u_min2));
    f_test_white=repmat(g_u,Bn1,1);
    %% power3 (correlation stationarity)
    gh_stationary=h_theta*g_u/mean(mean(f_res1));
    my_test(5)=max(max((f_res1_down1>gh_stationary)+(gh_stationary>f_res1_up1)));
    my_test(6)=max(max((f_res1_down2>gh_stationary)+(gh_stationary>f_res1_up2)));
    f_test_separable=gh_stationary;
    %% test (accept or reject)
    my_test=(my_test>0);
    disp('testing (a) stationarity at 0.05 and 0.1; (0 means accept, 1 means reject)');
    my_test(1:2)
    disp('testing (b) white noise at 0.05 and 0.1; (0 means accept, 1 means reject)');
    my_test(3:4)
    disp('testing (c) sepability at 0.05 and 0.1: (0 means accept, 1 means reject)');
    my_test(5:6)
    %% p-value
    if approx_conf==1
        % p-values for testing stationary
        my_crit_temp=(log(max(max(f_test_stationary./f_res1)))).^2;
        my_crit(1)=(log(min(min(f_test_stationary./f_res1)))).^2;
        my_crit(1)=max(my_crit(1),my_crit_temp);
        my_pval(1)=sum(mydata_maxdev>my_crit(1))/length(mydata_maxdev);
            % p-values for testing white noise
        my_crit_temp=(log(max(max(f_test_white./f_res1)))).^2;
        my_crit(2)=(log(min(min(f_test_white./f_res1)))).^2;
        my_crit(2)=max(my_crit(2),my_crit_temp);
        my_pval(2)=sum(mydata_maxdev>my_crit(2))/length(mydata_maxdev);
                % p-values for testing correlation stationary
        my_crit_temp=(log(max(max(f_test_separable./f_res1)))).^2;
        my_crit(3)=(log(min(min(f_test_separable./f_res1)))).^2;
        my_crit(3)=max(my_crit(3),my_crit_temp);
        my_pval(3)=sum(mydata_maxdev>my_crit(3))/length(mydata_maxdev);
        disp('p-values');
        my_pval
    else
        disp('I have not implement p-values for the cases approx_conf==0');
    end
   
    
 %% 
 figure(50); 
subplot(1,3,1); %
plot([1:N1],mydata); xlim([1 N1]); title(mydata_title); xlabel('time');
subplot(1,3,2); % time-frequency estimates in mesh
s1=mesh(f_res1);title('Time-frequency Estimates'); xlim([1 Cn1]); ylim([1 Bn1]); zlim([0 inf]); xlabel('time');ylabel('freq');
subplot(1,3,3); % time-frequency estimates in surface
surface(f_res1);title('Time-frequency Estimates'); xlim([1 Cn1]); ylim([1 Bn1]); zlim([0 inf]);
[X,Y]=meshgrid(1:Cn1,1:Bn1);xlabel('time');ylabel('freq');
%subplot(2,2,4); % 95% upper lower band in one plot
%s1=surf(X,Y,f_res1_up1); alpha(s1,0.1); title('95% Confidence Region');xlim([1 Cn1]); ylim([1 Bn1]);
%hold on
%s2=surf(X,Y,f_res1_down1); alpha(s2,0.6); xlim([1 Cn1]); ylim([1 Bn1]); zlim([0 inf]); xlabel('time');ylabel('freq');
%hold off

