%% Simulation 5: power test
%% 
% NOTE that my_power_test_model.m generate the signal
%
%%
clear all; clc; close all;
%% Length of Time Series
N=600; %num of data (e.g. 400 or 800)
delta_range=[0:0.1:0.7];%for TV-MA
%delta_range=[0:0.1:0.9]; %for TV-ARCH
%% Setting n and BnFFT
% TV-ARCH (N,n,BnFFT)= (800,72,32) or (600,72,32)
% TV-MA (N,n,BnFFT)=(800,300,32) or (600,300,32)
n=300; % n and BnFFT have been chosen already 
BnFFT=32; %BnFFT<n
Bn=floor(BnFFT/2); % Bn: the effective number of frequencies is half of BnFFT+1 (discarded the last one)
if BnFFT>n
    disp('error: BnFFT>n');
    return;
end
%% Generating u
du=n/N*(1-1/(log(Bn))^2); % du: fixed interval size between time
u=[n/2/N:du:1-n/2/N]'; % u: the vector of times 
Cn=size(u,1); % Cn: number of time points

%% Monte Carlo Setting
myplots=0; % don't plot figures when myplot=0;


per1=0.95; % per: 95% or 90%
per2=0.9;
MonteCarlo1=10000; % MonteCarlo1: number of Monte Carlo for generating bootstrapped interval
MonteCarlo2=10000; % MonteCarlo2: number of Monte Carlo for testing



%% Monte Carlo 1: generate bootstrapped interval

[int1_l,int1_r,int2_l,int2_r,boot_maxdev,boot_avg]=my_bootstrap_fft(u,N,n,BnFFT,Bn,MonteCarlo1,per1,per2);

disp('generated interval by bootstrapping: ');
[int1_l,int1_r]
[int2_l,int2_r]
%% Monte Carlo 2: test interval (Generating data from my_power_test_model.m

%int1_r=3.8565;
%int2_r=2.9915;


my_powers=my_power_test_fft(u,N,n,BnFFT,Bn,MonteCarlo2,int1_r,int2_r,delta_range);
disp(' Power: 95% Sta, 90% Sta, 95% White, 90% White, 95% Corr Sta, 90% Corr Sta');
my_powers

figure(1);
plot(delta_range,my_powers(:,1),'-.',delta_range,my_powers(:,2),'--');legend('95% confidence region','90% confidence region');
title('Testing stationarity');xlabel('\delta');ylabel('power');

figure(2);
plot(delta_range,my_powers(:,3),'-.',delta_range,my_powers(:,4),'--');legend('95% confidence region','90% confidence region');
title('Testing time-varying white noise');xlabel('\delta');ylabel('power');

figure(3);
plot(delta_range,my_powers(:,5),'-.',delta_range,my_powers(:,6),'--');legend('95% confidence region','90% confidence region');
title('Testing correlation stationarity');xlabel('\delta');ylabel('power');

load('powers.mat');
figure(88);
plot(delta_range_ARCH,my_powers_ARCH_N800(:,1),'r-',delta_range_ARCH,my_powers_ARCH_N800(:,2),'b--',delta_range_ARCH,my_powers_ARCH_N600(:,1),'k:',delta_range_ARCH,my_powers_ARCH_N600(:,2),'m-.');legend('95% SCR (N=800)','90% SCR (N=800)','95% SCR (N=600)','90% SCR (N=600)');
title('Testing stationarity');xlabel('\delta');ylabel('power');

figure(99);
plot(delta_range_MA,my_powers_MA_N800(:,3),'r-',delta_range_MA,my_powers_MA_N800(:,4),'b--',delta_range_MA,my_powers_MA_N600(:,3),'k:',delta_range_MA,my_powers_MA_N600(:,4),'m-.');legend('95% SCR (N=800)','90% SCR (N=800)','95% SCR (N=600)','90% SCR (N=600)');
title('Testing time-varying white noise');xlabel('\delta');ylabel('power');
