%% simulation 7, testing time-varying AR/ARMA model for real data
%clear all; clc; close all;
pAR=5;
qAR=1;
%% load data sets
load('EQ5.mat'); %load data (earthquake)
load('EXP6.mat'); %load data (explosion)
load('Speech.mat'); %load data (speech data)
load('data_SP500.mat');
%% choose one data from (EQ5, EXP6, normalized-centered-Speech)
%% approx_conf: 0: data is not long enough, don't approx conf interval
%% choose Earthquake data
%approx_conf=1; mydata=EQ5; mydata_title='Earthquake Data';t1=4;t2=6;t3=8;t4=10;f1=2;f2=4;f3=6;f4=8;
%% choose Exploison data
%approx_conf=1; mydata=EXP6; mydata_title='Explosion Data';t1=4;t2=6;t3=8;t4=10;f1=2;f2=4;f3=6;f4=8;
%% (not used) choose speech data
%NOT USED approx_conf=0; mydata=(Speech-mean(Speech))/(max(abs(Speech-mean(Speech)))); mydata_title='Speech Data';t1=1;t2=4;t3=7;t4=10;f1=3;f2=4;f3=5;f4=6;
%% I computed return by (data_SP500_Close-data_SP500_Open)./data_SP500_Open;
%% choose SP500 data, pure return (centered), data is long enough, choose approx confidence interval
%my_save=1; approx_conf=1; mydata=data_SP500_return-mean(data_SP500_return); mydata_title='daily return of SP500'; t1=5;t2=10;t3=15;t4=20;f1=6;f2=8;f3=10;f4=12;
%% SP500 abs return (remove mean by smoothing)
 % for smoothing
 my_bandwidth=sqrt(length(data_SP500_return)); %choose bandwidth for smoothing
 my_raw=abs(data_SP500_return);
 my_smooth=smoothing(abs(data_SP500_return),my_bandwidth);
 figure(999); N1=length(my_raw); plot([1:N1],my_raw,':',[1:N1],my_smooth,'-k'); xlabel('time'); legend('Absolute Daily Return','Kernel Smoothing');
 my_save=1; approx_conf=1; mydata=my_raw-my_smooth; mydata_title='centered abs daily return'; t1=2;t2=10;t3=16;t4=20;f1=1;f2=3;f3=5;f4=7;
%%
N=length(mydata);
figure(1);plot([1:N],mydata); xlim([1 N]); title('raw data');
%% use saved selected n and BnFFT to save time if my_save=1
if my_save==1
    n=314; BnFFT=37;
else
    %% select n and BnFFT for data
    [n,BnFFT]=my_select_n_BnFFT(mydata);
    disp('plug the selected BnFFT and n into 2*log(BnFFT)*BnFFT/n: '); 2*log(BnFFT)*BnFFT/n
end

%%
Bn=floor(BnFFT/2); % Bn: the effective number of frequencies is half of BnFFT+1 (discarded the last one)
if (BnFFT>n)
    disp('error: BnFFT>n');
    return;
end
%% Generating u
du=n/N*(1-1/(log(Bn))^2); % du: fixed interval size between time
u=[n/2/N:du:1-n/2/N]'; % u: the vector of times 
Cn=size(u,1); % Cn: number of time points


%% generate bootstrapped interval for mydata
per1=0.95; % per: 95% or 90%
per2=0.9;
MonteCarlo1=10000; % MonteCarlo1: number of Monte Carlo for generating bootstrapped interval
MonteCarlo2=100; % run optimization several times with rand initial points
if my_save==1 %load bootstrap results
    load('maxdev_sp500');
else
%    load('maxdev_sp500');% n and BnFFT are the same for SP500 and SP500abs
% bootstrap 95% and 90% interval for mydata
    [int1_l,mydata_int1,int2_l,mydata_int2,mydata_maxdev,mydata_avg]=my_bootstrap_fft(u,N,n,BnFFT,Bn,MonteCarlo1,per1,per2);
end

%% time-frequency estimates of mydata
f_min=0; %check how small fval could be

f_nonpara=zeros(Cn,Bn);
f_local_period=zeros(Cn,Bn);
f_local_para=zeros(Cn,Bn);
f_para=zeros(Cn,Bn);

local_fit=zeros(Cn,pAR+qAR+1);%save local fitted parameters
for ii=1:Cn
    ii/Cn
    my_u=u(ii);
    f_nonpara(ii,:)=my_spectral_estimate_fft(mydata,n,BnFFT,Bn,my_u)';
    f_local_period(ii,:)=my_local_periodogram_fft(mydata,n,BnFFT,Bn,my_u)';
      %% fit AR using local whittle
        % define local optimization objective
        %f_local = @(my_para)local_whittle_AR_p(my_para,pAR,BnFFT,Bn,f_local_period(ii,:));
        %% fit AR using log local whittle (added constant before logarithm to make it positive)
        f_local = @(my_para)log_local_whittle_ARMA_pq(my_para,pAR,qAR,BnFFT,Bn,f_local_period(ii,:));
        % optimization
        %myA=zeros(pAR+1,pAR+1);
        %myA(1,1)=-1
        %myb=[0,ones(1,pAR)*inf];
        %myA=[eye(pAR+1);-eye(pAR+1)];
        %myb=ones(2*(pAR+1),1);
        %[my_opt_para,fval]=fmincon(f_local,[1,zeros(1,pAR)],myA,myb);
        %% optimization with initial value all one
        [my_opt_para,fval]=fminsearch(f_local,ones(1,pAR+qAR+1));
        f_min=fval; 
        local_fit(ii,:)=my_opt_para;
      %% repeat optimization with random initial value
      for mmm=2:MonteCarlo2 %more times with different initials
           [my_opt_para,fval]=fminsearch(f_local,100*rand(1,pAR+qAR+1));
        if f_min>fval
            f_min=fval;
            local_fit(ii,:)=my_opt_para; %store 
        end
      end
      %%
        % compute local parametric density
        f_local_para(ii,:)=my_ARMA_density(local_fit(ii,1:qAR+1),local_fit(ii,qAR+2:length(my_opt_para)),BnFFT,Bn);
end

    %% test hypothesis
    %    res1=(f_para./f_nonpara-1).^2; % this is confidence region for parametric
        res2=(f_local_para./f_nonpara-1).^2; % confidence region for local parametric
        res3=(f_local_period./f_nonpara-1).^2; % confidence region for local period
   % my_largest1=max(max(res1));
    my_largest2=max(max(res2));
    my_largest3=max(max(res3));
    %find(res==my_largest);
    %my_pval1=sum(mydata_maxdev>my_largest1)/length(mydata_maxdev);
    my_pval2=sum(mydata_maxdev>my_largest2)/length(mydata_maxdev);
    %my_pval3=sum(mydata_maxdev>my_largest3)/length(mydata_maxdev);
    %disp('p-value for parametric'); my_pval1
    disp('p-value for local parametric'); my_pval2 
    
    %% 
   
%    disp('p-value for local periodogram'); my_pval3
% plot time-frequency estimates
str_title_local = sprintf('tv ARMA(%d,%d)',pAR,qAR);
%str_title_nonlocal = sprintf('AR(%d)',pAR);
 figure(2); mesh(f_nonpara'); title('nonparametric');
 figure(3); mesh(f_local_period'); title('local periodogram');
 figure(4); mesh(f_local_para'); title(str_title_local);
 %figure(5); mesh(f_para'); title(str_title_nonlocal);
 %figure(6); plot([1:Cn],my_sigma,[1:Cn],my_fitted_sigma); title('fitted sigma');
 %figure(7); plot([1:Cn],my_a(:,1),[1:Cn],my_fitted_a(:,1));title('fitted a1');
 figure(8); 
 subplot(2,2,1);mesh(f_nonpara'); title('nonparametric');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 subplot(2,2,2);mesh(f_local_period'); title('local periodogram');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 subplot(2,2,3);mesh(f_local_para'); title(str_title_local);xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 %subplot(2,2,4);mesh(f_para'); title(str_title_nonlocal);xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 
 % summarize within one plot for SP500
%  figure(9);
%  subplot(2,2,1);mesh(f_nonpara'); title('nonparametric');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
%  subplot(2,2,2);mesh(f_local_period'); title('local periodogram');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
%  subplot(2,2,3);mesh(f_local_para_p1'); title('local AR(1)');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
%  subplot(2,2,4);mesh(f_local_para_p3'); title('local AR(3)');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 
 %summarize within one plot for SP500abs
%  load('tvARMA.mat');
 figure(9);
 subplot(3,2,1);mesh(f10'); title('tv-AR(1)');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 subplot(3,2,2);mesh(f40'); title('tv-AR(4)');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 subplot(3,2,3);mesh(f50'); title('tv-AR(5)');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 subplot(3,2,4);mesh(f11'); title('tv-ARMA(1,1)');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 subplot(3,2,5);mesh(f21'); title('tv-ARMA(2,1)');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 subplot(3,2,6);mesh(f31'); title('tv-ARMA(3,1)');xlabel('time');ylabel('frequency');xlim([1,Cn]);ylim([1,Bn]);
 
