%% Function to estimate the spectral density of X at normalized time u and frequency theta
function f_hat=my_local_periodogram_fft(X,n,BnFFT,Bn,u)

N=length(X);

%% debug
if u<0 | u>1 | n>N |  BnFFT>n
    disp('error in my_spectral_estimate: u<0 or u>1 or n>length(X) or Bn>n');
    f_hat=nan;
    return
end

%% absolute time t from normalized time u
t=round(u*N); 
t=min(t,N-n/2);
t=max(t,n/2); % n/2<=t<=N-n/2

%%
r_hat=zeros(BnFFT,1); % k=0,1,..., Bn, ignored negative k since it's symmetric
weights=zeros(BnFFT,1); %weights=a(k/Bn)*exp(ik theta) +a(-k/Bn)*exp(-ik theta);
%% tappered X first
X=my_kernel_tau(X,t,n);
for k=0:BnFFT-1 %avoid double for loop
   % r_hat(k+1)=1/n*(X(t+1:t+n-k)'*X(t+1+k:t+n))*my_kernel(k/BnFFT);
   %% 
   %% local periodogram, no tapper here
    r_hat(k+1)=1/n*(X(round(t+1-floor(n/2)):round(t+n-floor(n/2)-k))'*X(round(t+1+k-floor(n/2)):round(t+n-floor(n/2)))); %temp! from -n/2 to n/2
   % weights(k+1)=cos(k*theta); % NOTE: I assumed a() is even function
end

%f_hat=1/2/pi*(2*r_hat'*weights);
spec_fft=fft(r_hat);
power_fft=(spec_fft+conj(spec_fft))/2/2/pi; 
%gap=floor(BnFFT/Bn);
f_hat=power_fft(1:Bn);