function my_powers=my_power_test_fft(u_vec,N,n,BnFFT,Bn,MonteCarlo,rr1,rr2,delta_range)
%% 
u_len=length(u_vec);
t_len=Bn;
    if size(delta_range,1)~=1
        delta_range=delta_range'; %delta_range should be a row vector of size (1,len)
    end
delta_len=length(delta_range);
%%
my_powers=zeros(delta_len,6);% 6 comes from (three power test * two levels)
%% critical value 
critical_a=sqrt(rr1);
critical_b=sqrt(rr2);
%% debug
if u_len~=size(u_vec,1) 
    disp('error in my_boostrap: u should be column vector');
    ll=nan; rr=nan;
    return
end
%%
%Total_pair=u_len*t_len;
%u_and_theta=[repmat(u_vec,t_len,1),vec(repmat(theta_vec,1,u_len)')];
%size(u_and_theta);
%u=u_vec(1); %TODO: change to maximum later
%theta=theta_vec(1); 

for ii=1:MonteCarlo
    %ii/MonteCarlo %print out percentage
    X=my_power_test_model(N,delta_range); % data generating process size(X)=(N,delta_len);
    power_tmp=zeros(size(my_powers)); 
    for kk=1:delta_len
        myboot=zeros(u_len,t_len); %
    for jj=1:u_len
        u=u_vec(jj); 
        myboot(jj,:)=my_spectral_estimate_fft(X(:,kk),n,BnFFT,Bn,u)';
    end
    %myboot is u_len*t_len f(u,theta) for given delta and montecarlo run ii
    %% power1 (stationarity): 
    h_theta=mean(myboot,1); %row vector
    h_theta_min=min(myboot); %row vector
    h_theta_max=max(myboot); %row vector
    power_tmp(kk,1)=max(((1-critical_a)*h_theta_max>h_theta)+(h_theta>(1+critical_a)*h_theta_min));
    power_tmp(kk,2)=max(((1-critical_b)*h_theta_max>h_theta)+(h_theta>(1+critical_b)*h_theta_min));
    %% power2 (white noise):
    g_u=mean(myboot,2); %column vector
    g_u_min=min(myboot')'; %column vector
    g_u_max=max(myboot')'; %column vector
    power_tmp(kk,3)=max(((1-critical_a)*g_u_max>g_u)+(g_u>(1+critical_a)*g_u_min));
    power_tmp(kk,4)=max(((1-critical_b)*g_u_max>g_u)+(g_u>(1+critical_b)*g_u_min));
    %% power3 (correlation stationarity)
    myboot_stationary=g_u*h_theta/mean(mean(myboot));
    power_tmp(kk,5)=max(max(((1-critical_a)*myboot>myboot_stationary)+(myboot_stationary>(1+critical_a)*myboot)));
    power_tmp(kk,6)=max(max(((1-critical_b)*myboot>myboot_stationary)+(myboot_stationary>(1+critical_b)*myboot)));
    end
    power_tmp=(power_tmp>0);
    my_powers=my_powers+power_tmp;
end
my_powers=my_powers/MonteCarlo;
