function X=my_power_test_model(N,delta_range)
%% true model for test power for a range of delta 
    if size(delta_range,1)~=1
        delta_range=delta_range'; %delta_range should be a row vector of size (1,len)
    end
    len=length(delta_range);
    eps_temp=normrnd(0,1,N,1); %use one sequence of epsilon to generate X for all delta
    epsilon=repmat(eps_temp,1,len);
    X=epsilon; %size=(N,len)
    Sigma2=zeros(size(X));
    %%
    for iii=2:N 
        %% time-varying ARCH model: (test stationarity)
        %Sigma2(iii,:)=0.3+(0.2+delta_range.*(iii/N)).*(X(iii-1,:).^2);
        %X(iii,:)=epsilon(iii,:).*sqrt(Sigma2(iii,:));
        %% the time-varying MA model: (test time-varying white noise) X[i]=0.3*e[i]+delta*(i/N)*e[i-1]
        X(iii,:)=(0.7+0.9*cos(2*pi*(iii/N))).*(epsilon(iii,:)+delta_range.*epsilon(iii-1,:));
        %%  the time-varying AR model:  X[i]=0.3*cos(2*pi*(i/N))X[i-1]+e[i]
        %X(iii,:)=delta_range*sin(2*pi*(iii/N))*X(iii-1,:)+0.5*cos(2*pi*(iii/N))*epsilon(iii,:);
        % plus a little bit
        %X(iii,:)=X(iii,:)+delta_range.*epsilon(iii-1,:);% this line is test line
    end
    X=X-repmat(mean(X,1),N,1); %subtract the mean; centralized before return the generated sequence