%% Function to estimate the spectral density of X at normalized time u and frequency theta
function f_hat=my_spectral_estimate(X,n,Bn,u,theta)

N=length(X);

%% debug
if u<0 | u>1 | n>N |  Bn>n
    disp('error in my_spectral_estimate: u<0 or u>1 or n>length(X) or Bn>n');
    f_hat=nan;
    return
end

%% absolute time t from normalized time u
t=floor(u*N); 
t=min(t,N-n); % 0<=t<=N-n

%%
r_hat=zeros(Bn,1); % k=0,1,..., Bn, ignored negative k since it's symmetric
weights=zeros(Bn,1); %weights=a(k/Bn)*exp(ik theta) +a(-k/Bn)*exp(-ik theta);
for k=0:Bn-1 %avoid double for loop
    %r_hat(k+1)=1/n*(X(t+1:t+n-k)'*X(t+1+k:t+n));
    r_hat(k+1)=1/n*(X(t+1-floor(n/2):t+n-floor(n/2)-k)'*X(t+1+k+-floor(n/2):t+n-floor(n/2))); %temp! from -n/2 to n/2
    weights(k+1)=my_kernel(k/Bn)*cos(k*theta); % NOTE: I assumed a() is even function
end

f_hat=1/2/pi*(2*r_hat'*weights);