clear all; clc; close all;
%% 
N=400; %num of data %1024
n=round(sqrt(N));%floor(N^(3/7)); %TODO: adjust n and Bn, 200
BnFFT=16; %BnFFT<n
Bn=floor(BnFFT/2);%floor(n^(2/3)); % NOte that effective number is just BnFFT/2+1
%% test for fixed u
Cn=20;
du=(N-n)/(Cn-1)/N;
u=[n/2/N:du:1-n/2/N]';
%theta=[2*pi/n; 2*pi*(n/4)/n; 2*pi*(n/1.5)/n];


%% Monte Carlo 1: generate bootstrapped interval
per=0.95;
MonteCarlo1=10000;
[int_l,int_r,boot_maxdev,boot_avg]=my_bootstrap_fft(u,N,n,BnFFT,Bn,MonteCarlo1,per);
%% Monte Carlo 2: test interval (Generating data from Model: X[i]=0.75*cos(2*pi*(i/N))X[i-1]+e[i])
MonteCarlo2=10000;
[my_per,test_maxdev,test_avg]=my_conf_int_test_fft(u,N,n,BnFFT,Bn,MonteCarlo2,int_l,int_r);

%% temp
[int_l,int_r]
my_per


figure(1);hist(boot_maxdev);title('Empirical Distribution of Bootstrapped Data'); axis([0 10 0 inf]);
figure(2);hist(test_maxdev);title('Monte Carlo Experiments of Non-stationary Data');axis([0 10 0 inf]);

%% empirical density estimate
[f1,x1]=ksdensity(boot_maxdev);
[f2,x2]=ksdensity(test_maxdev);
%% gumbel, but not used (since need scale and shift)
x3=[-5:0.1:20];
f3=exp(-x3);
f3=exp(-x3-f3);
%%
figure(3);plot(x1,f1,'--',x2,f2,'+');legend('Bootstrap','Test');%Gumbel need to rescale... so don't include it..


%% compare the true density
phi2=0.3*cos(2*pi*u);
phi1=zeros(length(phi2),1);
 theta=2*pi*[0:Bn-1]/(BnFFT);
 f1=zeros(1,length(boot_avg));
 f2=zeros(1,length(test_avg));
 for uu=1:length(phi2)
 f1((uu-1)*length(theta)+1:uu*length(theta))=1/2/pi./(1-2*phi1(uu)*cos(theta)+phi1(uu)^2);
 f2((uu-1)*length(theta)+1:uu*length(theta))=1/2/pi./(1-2*phi2(uu)*cos(theta)+phi2(uu)^2);
 end
 rescale1=mean(f1)/mean(boot_avg); % adjust the constant
 rescale2=mean(f2)/mean(test_avg); %rescale2 should equal rescale1
 rescale3=1/2; % fixed 0.5 for rescale 
 figure(4); 
 for uuu=1:min(length(u),9)
 subplot(3,3,uuu);
 plot(1:length(theta),boot_avg((uuu-1)*length(theta)+1:uuu*length(theta))*rescale3,'-.',1:length(theta),test_avg((uuu-1)*length(theta)+1:uuu*length(theta))*rescale3,'*-');axis([1,length(theta),-Inf,Inf]);
 stitle=sprintf('Est f(u=%0.2f,.)',u(uuu));
 title(stitle);
 end
 figure(5); 
for uuu=1:min(length(u),9)
    subplot(3,3,uuu);
 plot(1:length(theta),f1((uuu-1)*length(theta)+1:uuu*length(theta)),'-.',1:length(theta),f2((uuu-1)*length(theta)+1:uuu*length(theta)),'*-');axis([1,length(theta),-Inf,Inf]);
  stitle=sprintf('True f(u=%0.2f,.)',u(uuu));
 title(stitle);
end
